// decimate:
// take an array of samples and compute
// decimated output. Filtering is performed before
// decimation to avoid aliasing.
// It omits unnecessary computation for outputs which will be
// thrown away later.
//
// limitation: number of samples must be integral multiple of
// the interpolation factor
//
  
#include <stdlib.h>
#include "Decimator.h"

void Decimator::decimate(float x[], int len, float out[]) {
  int m = 0;			// output index

  for (int k = 0; k < len; ) {
      
    for (int n = 0; n < factor; n++) {
      buf[in_idx++] = x[k++];
      if (in_idx >= n_tap) {
	in_idx -= n_tap;
      }
    }
      
    int j = in_idx - 1;
    if (j < 0)
      j = n_tap - 1;
    double y = 0.0;    
    for (int i = 0; i < n_tap; ++i) {
      if (j < 0)
	j += n_tap;
      y = y + coeff[i] * buf[j--];
    }
    out[m++] = (float)y;
  }
}

