/* 
 * Decimator class
 *
 */

#ifndef DECIMATOR_H
#define DECIMATOR_H

class Decimator {
 private:
  int factor;		// decimation factor
  float *coeff;	// filter coefficients
  int n_tap;		// number of taps(coefficients)
  int in_idx;		// index at which new data will be inserted
  float *buf;	// used as a circular buffer
  
 public:
  Decimator(float *a, int n_tap, int factor) {
    in_idx = 0;
    this->n_tap = n_tap;
    coeff = a;
    buf = (float *)(malloc(sizeof(float) * n_tap));
    this->factor = factor;
  }

public:
  void decimate(float x[], int len, float out[]);
};

#endif
