#include <stdlib.h>
#include "FIRFilter.h"

void dummy_filter(void) {
  // do nothing
}

inline float FIRFilter::do_filter(float x) {
  int i;
  double y = 0.0;

  buf[in_idx] = x;

  int j = in_idx;
  for (i = 0; i < n_tap; ++i) {
    if (j < 0)
      j += n_tap;
    y = y + coeff[i] * buf[j--];
  }
  
  in_idx++;
  if (in_idx >= n_tap)
    in_idx -= n_tap;
  
  return (float)y;
}

// do_filter: take an array of samples and compute
// the same number of filterd output.
// The contents of the array will be overriden
// by filtered output.
void FIRFilter::do_filter(float *x, int len) {
	
  for (int k = 0; k < len; ++k) {
    double y = 0.0;
    int j = in_idx;
    buf[in_idx] = x[k];
	    
    for (int i = 0; i < n_tap; ++i) {
      if (j < 0)
	j += n_tap;
      y = y + coeff[i] * buf[j--];
    }
    in_idx++;
    if (in_idx >= n_tap) {
      in_idx -= n_tap;
    }
    x[k] = (float)y;
  }
}


