#include "FIRFilter.h"
#include "Decimator.h"
#include "Interpolator.h"
#include "SinGen.h"
//#define TRBAND 300.0f
//#define ATTN 60.0f

class Generator {
  
private:
  Decimator *decimator;
  Interpolator *iInterpolator, *qInterpolator;
  FIRFilter *iFilter, *qFilter;
  SinGen *bfo;
  float ifreq;
  
  void filter_init(void);
  
public:
  int mode;
  int generating;
  float phase_adj;
  float gain_adj;

  Generator(void) {
    ifreq = 12000.0;
    bfo = new SinGen(12000.0f, 48000);
    mode = 1;
    generating = 0;
    phase_adj = 0;
    gain_adj = 0;
    filter_init();
  }
  void generate(float *in, float *out_i, float *out_q, int n);
  void set_iqfilter(float sf, float f1, float f2, float trband, float attn);
  void set_ifreq(float freq);
};

