// interpolate:
// takes an array of samples and compute
// interpolated output. Filtering is performed after
// interpolation to avoid aliasing.
// It omits unnecessary multiply with inserted zeros.
//
// limitation: number of samples must be integral multiple of
// the interpolation factor

#include <stdlib.h>
#include "Interpolator.h"

void Interpolator::interpolate(float x[], int len, float out[]) {
  int m = 0;			// output index
    
  for (int k = 0; k < len; k++) {
    buf[in_idx] = x[k];
    for (int n = 0; n < factor; n++) {
	
      double y = 0.0;
      int j = in_idx;
	
      for (int i = n; i < n_tap; i+=factor) {
	if (j < 0)
	  j += buf_length;
	y = y + coeff[i] * buf[j--];
      }
      out[m++] = (float)(factor * y);
    }
    in_idx++;
    if (in_idx >= buf_length) {
      in_idx -= buf_length;
    }
  }
}

