/* 
 * Interpolator class
 *
 */

#ifndef INTERPOLATOR_H
#define INTERPOLATOR_H

class Interpolator {
 private:
  int factor;		// interpolation factor
  float *coeff;	// filter coefficients
  int n_tap;		// number of taps(coefficients)
  int in_idx;		// index at which new data will be inserted
  float *buf;	// used as a circular buffer
  int buf_length;

 public:
  Interpolator(float *a, int n_tap, int factor) {
    in_idx = 0;
    this->n_tap = n_tap;
    coeff = a;
    this->factor = factor;

    buf_length = (n_tap / factor) + 1;
    buf = new float[buf_length];
    buf = (float *)(malloc(sizeof(float) * buf_length));
  }

public:
  void Interpolator::interpolate(float *x, int len, float *out);
};

#endif
